( function( $ ) {
    $( document ).ready( function() {

        var calendars = $( '.sp-calendar' );
        if ( !calendars.length ) return;

        calendars.each( function () {

            $( this ).datepicker( {
                dateFormat: 'yy-mm-dd',
                prevText: '<',
                nextText: '>',
                showOtherMonths: true,
                changeMonth: true,
                changeYear: true,
                constrainInput: true,
                showOn: 'button',
                buttonText: '<span class="dashicons dashicons-calendar"></span>'
            } );

        } );

    } );

    $( document ).ready( function() {

        var btn = $( '.generate-qr' );
        if ( !btn.length ) return;

        $( 'body' ).on( 'click', '.generate-qr', function ( e ) {
            e.preventDefault();
            var message = $(
                '<div class="modal fade" tabindex="-1" role="dialog" labelledby="message">'+
                    '<div class="modal-dialog" role="document">'+
                        '<div class="modal-content">'+
                            '<div class="modal-body">'+
                                '<div id="qrcode"></div>'+
                            '</div>'+
                        '</div>'+
                    '</div>'+
                '</div>' );
            $( 'body' ).append( message );
            message.modal( 'show' );
            message.on( 'hidden.bs.modal', function (e) {
                $( this ).remove();
            } );

            var code = $( this ).data( 'qr' );
            var qrCode = new QRCode( 'qrcode' );
            qrCode.makeCode( code );
        } );

    } );

    $( document ).ready( function() {

        var container = $( '.container-qr' );
        if ( !container.length ) return;

        var code = container.data( 'qr' );
        var qrCode = new QRCode( 'qrcode' );
        qrCode.makeCode( code );

    } );


} )( jQuery );