( function( $ ) {
    //script para empacar una factura
    $( document ).ready( function() {
        var btn = $( '.sp-pack-item' );
        if ( !btn.length ) return;


        btn.click( function () {

            var facNumber = $( this ).data( 'spitem' );

            panel( modalHeader, modalBody, modalFooter );

            modalFooter.on( 'click', function () {
                var server = $( this ).closest( '.modal' ).find( '#sp-server-code' ).val();
                if ( server == '' ) {
                    $( this )
                        .closest( '.modal' )
                        .find( '#sp-server-code' )
                        .before( '<p>Deve Ingresar un codigo valido</p>' );
                }
                else {
                    var items = { fac: facNumber, server: server };
                    packItem( 'sp_pack_item', items );
                }
            } );

        } );

    } );


    function panel( modalHeader, modalBody, modalFooter ) {

        var message = $(
            '<div class="modal fade" tabindex="-1" role="dialog" labelledby="message">'+
                '<div class="modal-dialog" role="document">'+
                    '<div class="modal-content"></div>'+
                '</div>'+
            '</div>' );

        if ( modalHeader != '' ) {
            var header = $( '<div class="modal-header"></div>' );
            header.append( modalHeader );
            message.find( '.modal-content' ).append( header );
        }
        if ( modalBody != '' ) {
            var body = $( '<div class="modal-body"></div>' );
            body.append( modalBody );
            message.find( '.modal-content' ).append( body );
        }
        if ( modalFooter != '' ) {
            var footer = $( '<div class="modal-footer"></div>' );
            footer.append( modalFooter );
            message.find( '.modal-content' ).append( footer );
        }

        $( 'body' ).append( message );
        message.modal( 'show' );
        message.on( 'hidden.bs.modal', function (e) {
            $( this ).remove();
        } );
    }

    function packItem( action, items ) {
        var data = {
            action : action,
            items : items
        };
        console.log( items );
        $.post( sp_ajax_object.ajax_url, data, function( response ) {} )
            .done( function() {} )
            .fail( function() {} )
            .always( function( response ) {
                console.log( response );
                var modal = $( '.modal' );
                if( modal.length ) {
                    modal.modal( 'hide' );
                }
            } );
    }

} )( jQuery );