<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class sd_ajax
{

    public function ajax_delivery()
    {


        $Option1 = sd_ajax::LeerFacturasVenta();

        if (!empty($Option1)) {
             $Option1[0]->tipo="A";
            echo json_encode($Option1);
            wp_die();
        } elseif (!empty($Option2 = sd_ajax::LeerNotasEntrega())) {
            $Option2[0]->tipo="C";
            echo json_encode($Option2);
            wp_die();
        } elseif (!empty($Option3 = sd_ajax::LeerEmpaque())) {
            $Option3[0]->tipo="U";
            echo json_encode($Option3);
            wp_die();
        } elseif (!empty($Option4 = sd_ajax::LeerEmtrega())) {
            $Option4[0]->tipo="V";
            echo json_encode($Option4);
            wp_die();
        } else {
            echo json_encode('');
            wp_die();
        }
    }
    public static function  LeerFacturasVenta ()
    {
        try { // Leer Facturas Venta

            $CodigoEntrega = $_POST['items']['cod_delivery'];
            $config = sd_utilities::get_config();
            $params = new sd_params();

            $params->CampoOrden = '';
            $params->ExpresionFiltro = "[ParaEntrega] = 1 AND [CodigoEntrega] = '" . $CodigoEntrega . "'";
            $params->Orden = '';
            $params->RegistroInicial = 0;
            $params->RegistrosPorPagina = 10;


            $client = new SoapClient($config['server']);

            $data = $client->Vta_Vta_LeerFacturasVenta(
                ['Parametros' => $params, '_token' => $_SESSION['sd_user_token']]
            );

            $status = json_decode($data->Vta_Vta_LeerFacturasVentaResult)->Status;


            if ($status == -101) {
                $session = new sd_sessions();
                $token = $session->get_token();

                $data = $client->Vta_Vta_LeerFacturasVenta(
                    ['Parametros' => $params, "_token" => $token]
                );
                $item = json_decode($data->Vta_Vta_LeerFacturasVentaResult);

            } else {
                $item = json_decode($data->Vta_Vta_LeerFacturasVentaResult);
            }


        } catch (Exception $e) {
            $errors = new sd_errors();
            $errors->error_handler('sdk', $e);
        }
        if ($item->Status == 0 && !empty($item->Data)) {
            $item->Data[0]->TipoDoc="A";
            return $item->Data;

        } else {
            $result = [];
            return $result;

        }
    }
    public static function LeerNotasEntrega()
    {
        try {
            $CodigoEntrega = $_POST['items']['cod_delivery'];
            $config = sd_utilities::get_config();
            $params = new sd_params();

            $params->CampoOrden = '';
            $params->ExpresionFiltro = "[ParaEntrega] = 1 AND [CodigoEntrega] = '" . $CodigoEntrega . "'";
            $params->Orden = '';
            $params->RegistroInicial = 0;
            $params->RegistrosPorPagina = 10;


            $client = new SoapClient($config['server']);

            $data = $client->Vta_NotE_LeerNotasEntrega(
                ['Parametros' => $params, '_token' => $_SESSION['sd_user_token']]
            );

            $status = json_decode($data->Vta_NotE_LeerNotasEntregaResult)->Status;


            if ($status == -101) {
                $session = new sd_sessions();
                $token = $session->get_token();

                $data = $client->Vta_NotE_LeerNotasEntrega(
                    ['Parametros' => $params, "_token" => $token]
                );
                $item = json_decode($data->Vta_NotE_LeerNotasEntregaResult);

            } else {
                $item = json_decode($data->Vta_NotE_LeerNotasEntregaResult);
            }
        } catch (Exception $e) {
            $errors = new sd_errors();
            $errors->error_handler('sdk', $e);
        }
        if ($item->Status == 0 && !empty($item->Data)) {


            return $item->Data;



        } else {
            $result = [];
            return $result;

        }

    }

    public static function LeerEmpaque(){
        try {
            $CodigoEntrega = $_POST['items']['cod_delivery'];
            $config = sd_utilities::get_config();
            $params = new sd_params();

            $params->CampoOrden = '';
            $params->ExpresionFiltro = "[ParaEntrega] = 1 AND [CodigoEntrega] = '" . $CodigoEntrega . "'";
            $params->Orden = '';
            $params->RegistroInicial = 0;
            $params->RegistrosPorPagina = 10;


            $client = new SoapClient($config['server']);

            $data = $client->Vta_Emp_LeerEmpaques(
                ['Parametros' => $params, '_token' => $_SESSION['sd_user_token']]
            );

            $status = json_decode($data->Vta_Emp_LeerEmpaquesResult)->Status;


            if ($status == -101) {
                $session = new sd_sessions();
                $token = $session->get_token();

                $data = $client->Vta_Emp_LeerEmpaques(
                    ['Parametros' => $params, "_token" => $token]
                );
                $item = json_decode($data->Vta_Emp_LeerEmpaquesResult);

            } else {
                $item = json_decode($data->Vta_Emp_LeerEmpaquesResult);
            }

        } catch (Exception $e) {
            $errors = new sd_errors();
            $errors->error_handler('sdk', $e);
        }
        if ($item->Status == 0 && !empty($item->Data)) {

         $item->Data[0]->document = "U";

            return $item->Data;


        } else {
            $result = [];
            return $result;

        }

    }

public static function LeerEmtrega()
{
    // Leer Entregas
    try {
        $CodigoEntrega = $_POST['items']['cod_delivery'];
        $config = sd_utilities::get_config();
        $params = new sd_params();

        $params->CampoOrden = '';
        $params->ExpresionFiltro = "[CodigoEntrega] = '" . $CodigoEntrega . "'";
        $params->Orden = '';
        $params->RegistroInicial = 0;
        $params->RegistrosPorPagina = 10;


        $client = new SoapClient($config['server']);

        $data = $client->Vta_Entr_LeerEntregas(
            ['Parametros' => $params, '_token' => $_SESSION['sd_user_token']]
        );

        $status = json_decode($data->Vta_Entr_LeerEntregasResult)->Status;


        if ($status == -101) {
            $session = new sd_sessions();
            $token = $session->get_token();

            $data = $client->Vta_Entr_LeerEntregas(
                ['Parametros' => $params, "_token" => $token]
            );
            $item = json_decode($data->Vta_Entr_LeerEntregasResult);

        } else {
            $item = json_decode($data->Vta_Entr_LeerEntregasResult);
        }

    } catch (Exception $e) {
        $errors = new sd_errors();
        $errors->error_handler('sdk', $e);
    }
    if ($item->Status == 0 && !empty($item->Data)) {
        return $item->Data;

    } else {
        $result = [];
        return $result;

    }
}
        public  function CrearEmtrega()
    {
        //Crear entrega
        try {

            $cliente = $_POST["items"]["client"];
            $sucursal = $_POST["items"]["sucursal"];
            $FechaEmision = $_POST["items"]["FechaEmision"];
            $numero = $_POST["items"]["numero"];
            $NumeroUnico = $_POST["items"]["NumeroUnico"];
            $TipoDocumento = $_POST["items"]["TipoDocumento"];


           $config = sd_utilities::get_config();
            $params = new sd_params();

            $params->CodigoCliente = $cliente;
            $params->CodigoSucursal = $sucursal;
            $params->CodigoUsuario  ='001';
            $params->FechaEntrega  = $FechaEmision;
            $params->NumeroDocumento = $numero;
            $params->NumeroUnico = $NumeroUnico;
            $params->TipoDocumento = $TipoDocumento;


            $client = new SoapClient($config['server']);

            $data = $client->Vta_Entr_CrearEntrega(
                ['ParamFacturaModel' => $params, '_token' => $_SESSION['sd_user_token']]
            );

            $status = json_decode($data->Vta_Entr_CrearEntregaResult)->Status;


            if ($status == -101) {
                $session = new sd_sessions();
                $token = $session->get_token();

                $data = $client->Vta_Entr_CrearEntrega(
                    ['ParamFacturaModel' => $params, "_token" => $token]
                );
                $item = json_decode($data->Vta_Entr_CrearEntregaResult);

            } else {
                $item = json_decode($data->Vta_Entr_CrearEntregaResult);
            }

        }
        catch (Exception $e) {
            $errors = new sd_errors();
            $errors->error_handler('sdk', $e);
        }

        if ($item->Status == 0 && !empty($item->Message)) {
            echo json_encode($item);
            wp_die();

        } else {
            $item = 0;
            echo json_encode($item);
            wp_die();

        }



    }


}



