<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class sd_delivery {


    public function CrearEntrega(){
        try {
            $CodigoEntrega = $_POST['items']['cod_delivery'];
            $config = sd_utilities::get_config();
            $params = new sd_params();

            $params->CampoOrden = '';
            $params->ExpresionFiltro = "[ParaEntrega] = 1 AND [CodigoEntrega] = '" . $CodigoEntrega . "'";
            $params->Orden = '';
            $params->RegistroInicial = 0;
            $params->RegistrosPorPagina = 10;


            $client = new SoapClient($config['server']);

            $data = $client->Vta_Emp_LeerEmpaques(
                ['Parametros' => $params, '_token' => $_SESSION['sd_user_token']]
            );

            $status = json_decode($data->Vta_Emp_LeerEmpaquesResult)->Status;


            if ($status == -101) {
                $session = new sd_sessions();
                $token = $session->get_token();

                $data = $client->Vta_Emp_LeerEmpaques(
                    ['Parametros' => $params, "_token" => $token]
                );
                $item = json_decode($data->Vta_Emp_LeerEmpaquesResult);

            } else {
                $item = json_decode($data->Vta_Emp_LeerEmpaquesResult);
            }

        } catch (Exception $e) {
            $errors = new sd_errors();
            $errors->error_handler('sdk', $e);
        }
        if ($item->Status == 0 && !empty($item->Data)) {
            return $item->Data;

        } else {
            $result = [];
            return $result;

        }

    }
}