<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class sd_sessions {


    public function get_token() {
        try {
            $config = sd_utilities::get_config();

            $client = new SoapClient( $config[ 'server' ] );
            $login = $client->SEG_LoginSaint(
                [ "idUser" => $config[ 'user' ], "password" => $config[ 'user_password' ] ]
            );

            $token = json_decode( $login->SEG_LoginSaintResult )->Message;
            $_SESSION[ 'sd_user_token' ] = $token;
           return $token;
        }
        catch( Exception $e ) {
           // echo $e;
            $error_handler = new sd_errors();
            $error_handler->token_error_handler();
        }
    }
}