<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
?>
<div class = "wrap">
    <h1><?php esc_html_e( 'Saint Delivery Ajustes' , 'saintpackages' );?></h1>
    <?php
    $active_tab = isset( $_GET[ 'tab' ] ) ? $_GET[ 'tab' ] : 'display_sd_settings';
    $active_tab = isset( $_GET[ 'tab' ] ) ? $_GET[ 'tab' ] : 'display_sd_users';

    if ( isset( $_GET['settings-updated'] ) ) {
        echo "<div class='notice notice-success is-dismissible'><p>".__( 'Ajustes Actualizados Correctamente', 'saintpackages' )."</p></div>";
    } ?>

    <form method="post" action="options.php">
        <h2 class="nav-tab-wrapper">
            <a href="?page=saint-delivey-admin&tab=display_sd_settings" class="nav-tab <?php echo $active_tab == 'display_sd_settings' ? 'nav-tab-active' : ''; ?>"><?php esc_html_e( 'Ajustes Básicos' , 'saintpackages' );?></a>
            <a href="?page=saint-delivey-admin&tab=display_sd_users" class="nav-tab <?php echo $active_tab == 'display_sd_users' ? 'nav-tab-active' : ''; ?>"><?php esc_html_e( 'Usuarios' , 'saintpackages' );?></a>
        </h2>

        <?php
          switch ( $active_tab ) {
            case 'display_sd_settings' :
              settings_fields( 'sd_settings' );
              do_settings_sections( 'saint-delivey-admin&tab=display_sd_settings' );
              break;
              case 'display_sd_users' :
                  settings_fields( 'sd_users' );
                  do_settings_sections( 'saint-delivey-admin&tab=display_sd_users' );
                  break;
          }
        if ( $active_tab == 'display_sd_settings' ) {
            submit_button();
        }
        ?>

    </form>

</div>